/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CK_BUTTONCONTROL_H_
#define _CK_BUTTONCONTROL_H_

#include "ckControl.h"
#include "ckControlImp.h"

class ckPainter;


class ckButtonControl : public ckControl, public ckControlFactory<ckButtonControl>
{
    friend class ckControlFactory<ckButtonControl>;
public:

    virtual void acceptPainter(ckPainter &painter);

    virtual ckError performAction(string const &action, ckValueWrapper &wrapper);
    virtual ckError retreiveVariable(string const &var, string &value);

    virtual void createwindow(DWORD xstyle, const char *classname, const char *windowname, DWORD style,
                    int x, int y, int w, int h, HWND parent, HMENU menu, HINSTANCE hinstance);

    //static ckControl::ControlStyleT *getstylegallery() {return _buttonstyle;}
    //static ckControl::ControlStyleT *getxstylegallery() {return _buttonstyle;}

    //virtual DWORD _parseStyle();

    Pen * getLight() { return _bevellight.get(); }
    Pen * getDark() { return _beveldark.get();}

protected:
    ckButtonControl();
    virtual ControlStyleT * _getstyle(DWORD &style) { return _buttonstyle;}

    auto_ptr<Pen> _bevellight;
    auto_ptr<Pen> _beveldark;


    static ckControl::ControlStyleT _buttonstyle[];    
};

#endif