/*
Copyright (C) 2000 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "ckDialog.h"
#include "ckControlImp.h"
#include "ckControl.h"
#include "ckDialogControl.h"
#include "ckStaticControl.h"
#include "ckScanner.h"
#include "ckStream.h"
#include "ckValueWrapper.h"

//
// ckDialogImp
//
ckError ckDialogImp::show(ckValueWrapper &wrapper, ckControl &control) 
{
    _LSDEBUG1("ckDialogImp::show() is called");
    _LSDEBUG1("WARNING: we dont support variables for now");
    string str;
    ckError error = wrapper.getStringWithLength(str, false);

    if(error != SUCCESS || stricmp(TRUE_SYMBOL, str.c_str()) == 0)
    {
        ::ShowWindow(control.getHWND(), SW_SHOW);
    }
    else if(stricmp(CLOSE_SYMBOL, str.c_str()) == 0)
    {
        ::SendMessage(control.getHWND(), WM_CLOSE, 0, 0);   
    }
    else
    {
        ::ShowWindow(control.getHWND(), SW_HIDE);
    }
    return SUCCESS;
}

ckError ckDialogImp::resize(ckValueWrapper &wrapper, ckControl &control) 
{
    _LSDEBUG1("ckDialogImp::resize() is called");    
    _LSDEBUG1("WARNING: we dont support variables for now");
    int w, h;
//  RECT r;
    ckError error;
    error = wrapper.getInt(w);
    _LSDEBUG1("ckDialogImp::resize() we don't support variable for now");
    if(error == SUCCESS)
    {
        error = wrapper.getInt(h);
        if(error == SUCCESS)
        {
            // resize it, then get the size and sprintf back, since we don't accept variable
            // for now, otherwise need to get the first two from size, and append the variable
            // int string then evaluate.
            _LSDEBUG1("WARNING: we are going to overwite the size value now");
            SetWindowPos(control.getHWND(), NULL, 0, 0, w, h, SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOZORDER|SWP_NOOWNERZORDER);
            
            /*
            if(control.parentHWND() != NULL)
            {//a control children
                GetClientRect(control.getHWND(), &r);
            }
            else
            {
                GetWindowRect(control.getHWND(), &r);
            }
            //it's updated only when user query for the value
            _LSDEBUG1("need to be refined");
            char buffer[0xFF];
            sprintf(buffer, "%d %d %d %d", r.left, r.top, r.right-r.left, r.bottom-r.top);
            control.addAttribute(SIZE_ATTRIB, buffer);
            */
        }
    }

    return error;
}

ckError ckDialogImp::move(ckValueWrapper &wrapper, ckControl &control)
{
    _LSDEBUG1("ckDialogImp::move() is called");
    _LSDEBUG1("WARNING: we dont support variables for now");
    int x, y;
    RECT r;
    ckError error;
    error = wrapper.getInt(x);
    
    if(error == SUCCESS)
    {
        error = wrapper.getInt(y);
        if(error == SUCCESS)
        {
            // resize it, then get the size and sprintf back, since we don't accept variable
            // for now, otherwise need to get the first two from size, and append the variable
            // int string then evaluate.
            _LSDEBUG1("WARNING: we are going to overwite the size value now");
            SetWindowPos(control.getHWND(), NULL, x, y, 0, 0, SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOOWNERZORDER|SWP_NOSIZE);


            char buffer[0xFF];
            _LSDEBUG1("Dumping rects...");
            //we'll have to see if only using this works
            _LSDEBUG1("GetClientRect");
            GetClientRect(control.getHWND(), &r);
            sprintf(buffer, "left = %d, top = %d, right = %d, bottom = %d", r.left, r.top, r.right, r.bottom);
            _LSDEBUG1(buffer);
            _LSDEBUG1("GetWindowRect");
            GetWindowRect(control.getHWND(), &r);
            sprintf(buffer, "left = %d, top = %d, right = %d, bottom = %d", r.left, r.top, r.right, r.bottom);
            _LSDEBUG1(buffer);    
            /*
            //it's updated only when user query for the value
            _LSDEBUG1("need to be refined");
            //sprintf(buffer, "%d %d %d %d", r.left, r.top, r.right-r.left, r.bottom-r.top);
            //control.addAttribute(SIZE_ATTRIB, buffer);
            */
        }
    }

    return error;
}

ckError ckDialogImp::state(ckValueWrapper &wrapper, ckControl &control) 
{
    _LSDEBUG1("ckDialogImp::state() is called");
    _LSDEBUG1("WARNING: we dont support variables for now");
    // parse state
    ckError error;
    string str, arg;
    bool status;

    error = wrapper.getStringWithLength(str, false);
    if(error == SUCCESS)
    {
        _LSDEBUG2("ckDialogImp::state() with state: %s", str.c_str());
        _LSDEBUG2("ckDialogImp::state() argument: %s", arg.c_str());
        error = wrapper.getStringWithLength(arg, false);
        status = (error != SUCCESS) || (stricmp(arg.c_str(), TRUE_SYMBOL) == 0);

        error = 
            (_focus(str, control.getHWND()) || _enable(str, status, control.getHWND()))  
            ? SUCCESS : NOT_SUPPORTED;
    }

    return SUCCESS;
}

//
// set
//
// set can have special weird characters, so we don't do scanner valid checking
ckError ckDialogImp::set(ckValueWrapper &wrapper, ckControl &control) 
{
    _LSDEBUG1("ckDialogImp::set() is called");
    _LSDEBUG1("WARNING: we dont support variables for now");
    string str;

    wrapper.getScanner().accept();
    str= wrapper.getScanner().getString();
       
    //::SetWindowText(control.getHWND(), str.c_str());
    _setText(control, str);
    
    return SUCCESS;
}


ckError ckDialogImp::setui(ckValueWrapper &wrapper, ckControl &control)
{ 
    string str;
    ckError error = wrapper.getStringWithLength(str);
    if(error == SUCCESS && stricmp(str.c_str(), BITMAP_SYMBOL) == 0)
    {
        error = wrapper.getRawStringWithLength(str);
        if(error == SUCCESS)
        {
            _LSDEBUG1("WARNING: this is very bad");
            ((ckDialogControl &)control).LoadIcon(str);
        }
    }

    return error;
}


bool ckDialogImp::_enable(string const &str, bool status, HWND hwnd)
{
    if(stricmp(ENABLE_SYMBOL, str.c_str()) == 0)
    {
        _LSDEBUG2("Enabling with boolean :", (status) ? "true" : "false");
        ::EnableWindow( hwnd, status );
        return true;
    }
    return false;
}

bool ckDialogImp::_focus(string const &str, HWND hwnd)
{
    if(stricmp(FOCUS_SYMBOL, str.c_str()) == 0)
    {
        ::SetFocus(hwnd);
        return true;
    }

    return false;
}

void ckDialogImp::_setText(ckControl &control, string &str)
{
    ::SendMessage(control.getHWND(), WM_SETTEXT, 0, (LPARAM)str.c_str());
}

string ckDialogImp::_getText(ckControl &control)
{
    int length = _getTextLength(control);
    smart_array<char> temparray(new char[++length]);
    ::SendMessage(control.getHWND(), WM_GETTEXT, (WPARAM)length, (LPARAM)temparray.get());
    return temparray.get();
}

int ckDialogImp::_getTextLength(ckControl &control)
{
    return ::SendMessage(control.getHWND(), WM_GETTEXTLENGTH,0,0);
}


//
// ckStaticImp
//
ckError ckStaticImp::setui(ckValueWrapper &wrapper, ckControl &control)
{ 
    string str;
    ckError error = wrapper.getStringWithLength(str);
    if(error == SUCCESS && stricmp(str.c_str(), BITMAP_SYMBOL) == 0)
    {
        error = wrapper.getRawStringWithLength(str);
        if(error == SUCCESS)
        {
            _LSDEBUG1("WARNING: this is bad");
            ((ckStaticControl &)control).LoadBitmap(str);
        }
    }

    return error;
}


//
// ckButtonImp
//
ckError ckButtonImp::state(ckValueWrapper &wrapper, ckControl &control)
{
    _LSDEBUG1("ckDialogImp::state() is called");
    _LSDEBUG1("WARNING: we dont support variables for now");
    // parse state
    ckError error;
    string str, arg;
    bool status;

    error = wrapper.getStringWithLength(str, false);
    if(error == SUCCESS)
    {
        _LSDEBUG2("ckButtonImp::state() with state: %s", str.c_str());
        _LSDEBUG2("ckButtonImp::state() argument: %s", arg.c_str());
        error = wrapper.getStringWithLength(arg, false);
        status = (error != SUCCESS) || (stricmp(arg.c_str(), TRUE_SYMBOL) == 0);

        error = (   _focus(str, control.getHWND())          || 
                    _enable(str, status, control.getHWND()) ||
                    _push(str, status, control.getHWND())   ||
                    _check(str, arg, control.getHWND()) )
                ? SUCCESS : NOT_SUPPORTED;

    }

    return error;

}

bool ckButtonImp::_push(string const &str, bool status, HWND hwnd)
{
    if(stricmp(PUSH_SYMBOL, str.c_str()) == 0)
    {
        ::SendMessage(hwnd, BM_SETSTATE, (WPARAM) (status) ? TRUE : FALSE, 0);
        return true;
    }
    return false;
}

bool ckButtonImp::_check(string const &str, string const &arg, HWND hwnd)
{
    if(stricmp(CHECK_SYMBOL, str.c_str()) == 0)
    {
        DWORD checkstate;

        if(stricmp(TRUE_SYMBOL, arg.c_str()) == 0)
        {
            checkstate = BST_CHECKED;
        }
        else if(stricmp(DONTKNOW_SYMBOL, arg.c_str()) == 0)
        {
            checkstate = BST_INDETERMINATE;
        }
        else
        {
            checkstate = BST_UNCHECKED;
        }

        ::SendMessage(hwnd, BM_SETSTATE, (WPARAM)checkstate, 0);
        return true;
    }
    return false;
}


//
// ckLineImp
//
ckError ckLineImp::line(ckValueWrapper &wrapper, ckControl &control)
{
// arguemnts ( operation type, line #, text );
    _LSDEBUG1("ckLineImp::line() is called");
    int linenum;
    string str, temp;
    ckError error = wrapper.getStringWithLength(str, false);
    if(error == SUCCESS)
    {
        error = wrapper.getInt(linenum);

        if(error == SUCCESS)
        {
            //
            //  line add
            //
            if(stricmp(str.c_str(), ADD_SYMBOL) == 0)
            {
                _LSDEBUG1("ckLineImp::line() got add symbol");
                error = _add(linenum, wrapper, control);                
            }
            //
            //  line delete
            //
            else if(stricmp(str.c_str(), DELETE_SYMBOL) == 0)
            {
                _LSDEBUG1("ckLineImp::line() got delete symbol");
                error = _delete(linenum, wrapper, control);
            }
            //
            //  line overwrite
            //
            else if(stricmp(str.c_str(), OVERWRITE_SYMBOL) == 0)
            {
                _LSDEBUG1("ckLineImp::line() got overwrite symbol");
                error = _overwrite(linenum, wrapper, control);
            }
        }

    }
    
    _LSDEBUG2("ckLineImp::line() exiting with error code: %08X", (DWORD)error);
    return error;

}

//
// ckEditImp
//
ckError ckEditImp::_add(int num, ckValueWrapper &wrapper, ckControl &control)
{
    _LSDEBUG1("ckEditImp::_add()");
    ckError error = FAIL;
    string str;
    _LSDEBUG2("ckEditImp::_add() got string %s", str.c_str());
    wrapper.getRawString(str);
    str += "\r\n";

    if(num != -1)
    {
        /*
        string strtext = _getText(control.getHWND());
        int pos = 0;
        
        while(  num-- > 0 &&
                (pos = strtext.find('\n', pos)) != string::npos)
        continue;
        
        if(pos != string::npos)
        {
            if(pos != 0) ++pos; //skip '\n'                        
            //select the pos, and add our stuff
            _select(control, pos, pos);
            _replaceSelection(control, wrapper.getScanner().getStream().toString());
            //strtext.insert(pos, wrapper.getScanner().getStream().toString());
            //_setText(control, strtext);
            error = SUCCESS;
        }
        */
    
        int index = _getIndex(control, num);
        _LSDEBUG2("ckEditImp::_add() got index %d", index);

        if(index != -1)
        {
            _select(control, index, index);
            _replaceSelection(control, str);
            error = SUCCESS;
        }
    }

    if(error != SUCCESS)
    {                    
        /*
        _append(control,
                    wrapper.getScanner().getStream().toString());
        */
        _LSDEBUG1("ckEditImp::_add() didn't succeed or index == -1");
        _append(control, str);
    }

    return SUCCESS;
}


ckError ckEditImp::_delete(int num, ckValueWrapper &wrapper, ckControl &control)
{
    if(num == -1)
    {
        _LSDEBUG1("ckEditImp::_delete() deleting everything");
        _setText(control, string());
    }
    else
    {
        /*
        string strtext = _getText(control);
        int pos = 0, endpos;

        while(  num-- > 0 &&
                (pos = strtext.find('\n', pos)) != string::npos)
        continue;

        if(pos != string::npos)
        {
            if(pos != 0) ++pos; //skip '\n'
            endpos = strtext.find('\n', pos);
    
            _select(control, pos, (endpos != string::npos) ? endpos : -1);
            _replaceSelection(control, string());
            // select the pos and replace with blank
            //strtext.erase(pos, endpos); //npos is accepted
            //_setText(control, strtext);
        }
        */
        int startindex = _getIndex(control, num);
        int endindex = _getIndex(control, num+1);
        _LSDEBUG2("ckEditImp::_delete() deleting start: %d", startindex);
        _LSDEBUG2("ckEditImp::_delete() deleting end: %d", endindex);
        _select(control, startindex, endindex);
        _replaceSelection(control, string());
    }

    return SUCCESS;
}

ckError ckEditImp::_overwrite(int num, ckValueWrapper &wrapper, ckControl &control)
{
    string str;
    wrapper.getRawString(str);
    _LSDEBUG2("ckEditImp::_overwrite() got string: %s", str.c_str());
    str += "\r\n";

    if(num == -1)
    {
        _LSDEBUG1("ckEditImp::_overwrite() overwriting all");
        _setText(control, str);
    }
    else
    {
        /*
        string strtext = _getText(control);
        int pos = 0, endpos;
    
        while(  num-- > 0 &&
                (pos = strtext.find('\n', pos)) != string::npos)
        continue;
    
        if(pos != string::npos)
        {
            if(pos != 0) ++pos; //skip '\n'
            endpos = strtext.find('\n', pos);
        
            _select(control, pos, (endpos != string::npos) ? endpos : -1);
            _replaceSelection(control, str);
            // select the pos and replace with blank
            //strtext.erase(pos, endpos); //npos is accepted
            //_setText(control, strtext);
        }
        */
        int startindex = _getIndex(control, num);
        int endindex = _getIndex(control, num+1);
        _LSDEBUG2("ckEditImp::_overwrite() overwriting start: %d", startindex);
        _LSDEBUG2("ckEditImp::_overwrite() overwriting end: %d", endindex);
        _select(control, startindex, endindex);
        _replaceSelection(control, str);
    }

    return SUCCESS;
}

//
// Other Manipulation functions
//
inline void ckEditImp::_select(ckControl &control, int start, int end)
{   ::SendMessage (control.getHWND(), EM_SETSEL, start, end);    }

string ckEditImp::_getSelect(ckControl &control)
{
    int length = ::SendMessage(control.getHWND(), WM_GETTEXTLENGTH,0,0);
    smart_array<char> temparray(new char[++length]);
    ::SendMessage(control.getHWND(), WM_GETTEXT, (WPARAM)length, (LPARAM)temparray.get());
    return temparray.get();
}

inline int ckEditImp::_getIndex(ckControl &control, int number)
{
    return ::SendMessage(control.getHWND(), EM_LINEINDEX, (WPARAM)number, 0);
}

inline void ckEditImp::_selectAll(ckControl &control)
{   _select(control, 0, -1);    }

inline void ckEditImp::_clearSelect(ckControl &control)
{   _select(control, -1, 0);    }

inline void ckEditImp::_setAppend(ckControl &control)
{   
    _selectAll(control); 
    _clearSelect(control);  
}

inline void ckEditImp::_replaceSelection(ckControl &control, string const &str)
{   ::SendMessage(control.getHWND(), EM_REPLACESEL, (WPARAM)TRUE, (LPARAM)str.c_str());	}

inline void ckEditImp::_append(ckControl &control, string const &str)
{
    _setAppend(control);
    _replaceSelection(control, str);
}

//
// ckListBoxImp
//
ckError ckListBoxImp::_add(int num, ckValueWrapper &wrapper, ckControl &control)
{
    string str;
    LRESULT result;
    wrapper.getRawString(str);
    _LSDEBUG2("ckListBoxImp::_add() got string: %s", str.c_str());
    if(num == -1)
    {
        _LSDEBUG1("ckListBoxImp::_add() appending");
        result = ::SendMessage(control.getHWND(), LB_ADDSTRING, 0, (LPARAM)str.c_str());
    }
    else
    {
        _LSDEBUG2("ckListBoxImp::_add() inserting to: %d", num);
        result = ::SendMessage(control.getHWND(), LB_INSERTSTRING , (WPARAM)num, (LPARAM)str.c_str());
    }

    return (result != LB_ERR && result != LB_ERRSPACE) ? SUCCESS : FAIL;
}

ckError ckListBoxImp::_delete(int num, ckValueWrapper &wrapper, ckControl &control)
{
    LRESULT result;

    if(num == -1)
    {
        _LSDEBUG1("ckListBoxImp::_delete() reseting content");
        ::SendMessage(control.getHWND(), LB_RESETCONTENT, 0, 0);
        return SUCCESS;
    }
    else
    {
        _LSDEBUG2("ckListBoxImp::_delete() deleting line: %d", num);
        result = ::SendMessage(control.getHWND(), LB_DELETESTRING, (WPARAM)num, 0);
    }

    return (result != LB_ERR && result != LB_ERRSPACE) ? SUCCESS : FAIL;
}

ckError ckListBoxImp::_overwrite(int num, ckValueWrapper &wrapper, ckControl &control)
{
    ckError error;
    error = _delete(num, wrapper, control);
    error = _add(num, wrapper, control);
    return error;
}

//
// general
//
int ckListBoxImp::_getCount(ckControl &control)
{
    return ::SendMessage(control.getHWND(), LB_GETCOUNT, 0, 0);
}

string ckListBoxImp::_getText(ckControl &control, int num)
{
    _LSDEBUG0;
    int length = _getTextLength(control, num);
    smart_array<char> temparray(new char[++length]);
    ::SendMessage(control.getHWND(), LB_GETTEXT, (WPARAM)num, (LPARAM)temparray.get());
    _LSDEBUG0;
    return temparray.get();
}

int ckListBoxImp::_getTextLength(ckControl &control, int num)
{
    return ::SendMessage(control.getHWND(), LB_GETTEXTLEN, (WPARAM)num, 0);
}


smart_array<int> ckListBoxImp::_getSelItems(ckControl &control, int &total)
{
    //if multiple, we return array of indexes, if single
    //the array only has one index
    int selcount = _getSelCount(control);
    total = (selcount != -1) ? selcount : 1;
    smart_array<int> selitems(total);

    if(selcount != -1)
    {
        ::SendMessage(control.getHWND(), LB_GETSELITEMS, (WPARAM)selcount, (LPARAM)selitems.get());
    }
    else
    {
        selitems[0] = _getCurSel(control);
    }

    return selitems;
}

bool ckListBoxImp::_isSelected(ckControl &control, int num)
{
    int result = ::SendMessage(control.getHWND(), LB_GETSEL, (WPARAM)num, 0);
    return (result > 0 && result != LB_ERR);
}

//
// single selection
//
int ckListBoxImp::_getCurSel(ckControl &control)
{
    int result = ::SendMessage(control.getHWND(), LB_GETCURSEL, 0, 0);
    return (result != LB_ERR) ? result : -1;
}

//
// multiselection
//
int ckListBoxImp::_getSelCount(ckControl &control)
{
    int count = ::SendMessage(control.getHWND(), LB_GETSELCOUNT, 0, 0);
    return (count != LB_ERR) ? count : -1;
}

//
// ckComboBoxImp
//
// must rewrite to save dupe code
ckError ckComboBoxImp::_add(int num, ckValueWrapper &wrapper, ckControl &control)
{
    string str;
    LRESULT result;
    wrapper.getRawString(str);
    if(num == -1)
    {
        result = ::SendMessage(control.getHWND(), CB_ADDSTRING, 0, (LPARAM)str.c_str());
    }
    else
    {
        result = ::SendMessage(control.getHWND(), CB_INSERTSTRING, (WPARAM)num, (LPARAM)str.c_str());
    }

    return (result != LB_ERR && result != LB_ERRSPACE) ? SUCCESS : FAIL;
}


ckError ckComboBoxImp::_delete(int num, ckValueWrapper &wrapper, ckControl &control)
{
    LRESULT result;

    if(num == -1)
    {
        ::SendMessage(control.getHWND(), CB_RESETCONTENT, 0, 0);
        return SUCCESS;
    }
    else
    {
        result = ::SendMessage(control.getHWND(), CB_DELETESTRING, (WPARAM)num, 0);
    }

    return (result != LB_ERR && result != LB_ERRSPACE) ? SUCCESS : FAIL;
}

ckError ckComboBoxImp::_overwrite(int num, ckValueWrapper &wrapper, ckControl &control)
{ 
    ckError error;
    error = _delete(num, wrapper, control);
    error = _add(num, wrapper, control);
    return error;    
}


int ckComboBoxImp::_getCurSel(ckControl &control)
{
    LRESULT result = ::SendMessage(control.getHWND(), CB_GETCURSEL, 0, 0);
    return (result != CB_ERR) ? result : -1;
}

string ckComboBoxImp::_getText(ckControl &control, int num)
{
    int length = _getTextLength(control, num);
    smart_array<char> temparray(new char[++length]);
    ::SendMessage(control.getHWND(), CB_GETLBTEXT, (WPARAM)num, (LPARAM)temparray.get());
    return temparray.get();
}

int ckComboBoxImp::_getTextLength(ckControl &control, int num)
{
    LRESULT result = ::SendMessage(control.getHWND(), CB_GETLBTEXTLEN, (WPARAM)num, 0);
    return (result != CB_ERR) ? result : -1;
}

int ckComboBoxImp::_getCount(ckControl &control)
{
    LRESULT result = ::SendMessage(control.getHWND(), CB_GETCOUNT, 0, 0);
    return (result != CB_ERR) ? result : -1;
}


