/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef _CK_CONTROLPARSER_H_
#define _CK_CONTROLPARSER_H_

#include "ckParser.h"
class ckControlManager;

//
// control parser
//
class ckControlParser : public ckParser
{
public:
    ckControlParser(ckControlManager &manager)
    :   _manager(manager)
    {}

    virtual ~ckControlParser () {}

    virtual ckError parse(ckStream &ckstream) = 0;

protected:
    ckControlManager &_manager;
};

//
// dialog template parser
//  parses dialog templates in configuration file
class ckDialogParser : public ckControlParser
{
public:
	ckDialogParser(ckControlManager &manager);
	virtual ~ckDialogParser();
	
	virtual ckError parse(ckStream &ckstream);
};

//
// event handling parser
//  parses event handling code in configuration file
class ckEventHandlerParser : public ckControlParser
{
public:
    ckEventHandlerParser(ckControlManager &manager);
    virtual ~ckEventHandlerParser() {}

    virtual ckError parse(ckStream &ckstream);
};


#endif
