/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "ckDialog.h"
#include "ckControl.h"
#include "ckDialogControl.h"
#include "ckButtonControl.h"
#include "ckEditControl.h"
#include "ckListBoxControl.h"
#include "ckComboBoxControl.h"
#include "ckStaticControl.h"
#include "ckControlTable.h"


auto_ptr<ckControlTable> ckControlTable::_instance;

ckControlTable::ckControlTableT ckControlTable::_table[] = 
{
    {DIALOG_TYPE    ,   ckDialogControl::Make   },
    {BUTTON_TYPE    ,   ckButtonControl::Make   },
    {EDIT_TYPE      ,   ckEditControl::Make     },
    {LISTBOX_TYPE   ,   ckListBoxControl::Make  },
    {COMBOBOX_TYPE  ,   ckComboBoxControl::Make },
    {STATIC_TYPE    ,   ckStaticControl::Make   },
    {0, 0}
};


ckControlTable* ckControlTable::instance()
{
    _LSDEBUG0;
    if(_instance.get() == NULL)
    {
        _LSDEBUG0;
        _instance.reset(new ckControlTable);
        _LSDEBUG0;
        assert(_instance.get() != NULL);
        _LSDEBUG0;
    }

    _LSDEBUG0;
    return _instance.get();
}

// need to initalize our table in here
ckControlTable::ckControlTable()
{
    _LSDEBUG1("ckControlTable::ckControlTable() ctor");
    /*
    _LSDEBUG0;
    auto_ptr<ckControl> temp;
    _LSDEBUG0;

    int i=0;
    while(_table[i]._name != NULL)
    {
        _LSDEBUG0;
        addControl(_table[i]._name, _table[i]._pMake);

        _LSDEBUG0;
        temp = _table[i]._pMake();
        _LSDEBUG0;
        assert(temp.get() != NULL);
        _LSDEBUG0;
        temp->registerAttributeTable(*this);
        _LSDEBUG0;

        i++;
        _LSDEBUG0;
    }

    _LSDEBUG2("ckControlTable::ckControlTable() totally %d items added", i);
    */
    /*
    _LSDEBUG2("ckControlTable::ckControlTable() totally %d attribs added", (int)_attrib.size());
    for(set<string>::iterator it=_attrib.begin(); it != _attrib.end(); ++it)
    {
        _LSDEBUG2("ckControlTable::ckControlTable() contains item %s", it->c_str());
    }
    */
}

ckControlTable::~ckControlTable()
{
    _LSDEBUG1("ckControlTable::ckControlTable() ctor");
}

/*
void addControl(string const &name, pMake ptr)
{
    assert(!findControl(name));
    _control[name] = ptr;
}
*/

/*
void addAttribute(string const &attrib)
{
    _attrib.insert(attrib);
}
*/

pMake ckControlTable::findControl(string const &name)
{
    /*
    map<string, pMake>::iterator it = _control.find(name);
    return (it != _control.end()) ? it->second : NULL;
    */
    int i = 0;
    while(_table[i]._name)
    {
        if(stricmp(name.c_str(), _table[i]._name) == 0)
            return _table[i]._pMake;
        ++i;
    }

    return NULL;
}