/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CK_GLOBAL_H_
#define _CK_GLOBAL_H_


// make sure they are lowercased
//
// CONTROL TYPE
//
#define DIALOG_TYPE                 "dialog"
#define BUTTON_TYPE                 "button"
#define EDIT_TYPE                   "edit"
#define LISTBOX_TYPE                "listbox"
#define COMBOBOX_TYPE               "combobox"
#define STATIC_TYPE                 "static"

#define TYPE_ATTRIB                 "type"
#define ID_ATTRIB                   "id"
#define TITLE_ATTRIB                "title"
#define SIZE_ATTRIB                 "size"
#define STYLE_ATTRIB                "style"
#define XSTYLE_ATTRIB               "xstyle"
#define FONTFACE_ATTRIB             "font"
#define FONTCOLOR_ATTRIB            "fontcolor"
#define BGCOLOR_ATTRIB              "bgcolor"
#define BEVELLIGHT_ATTRIB           "bevellight"
#define BEVELDARK_ATTRIB            "beveldark"
#define SELELECTCOLOR_ATTRIB        "selcolor"
#define SELECTTEXTCOLOR_ATTRIB      "selfontcolor"
#define BITMAP_ATTRIB               "bitmap"
#define ICON_ATTRIB                 "icon"


//
// SPECIAL SYMBOLS
//
#define NEW_SYMBOL                  "new"
#define ENDNEW_SYMBOL               "~new"
#define HIDDENSYLE_SYMBOL           "wshidden"
#define TRUE_SYMBOL                 "true"
#define ENABLE_SYMBOL               "enable"
#define CHECK_SYMBOL                "check"
#define FOCUS_SYMBOL                "focus"
#define PUSH_SYMBOL                 "push"
#define DONTKNOW_SYMBOL             "dontknow"
#define ADD_SYMBOL                  "add"
#define DELETE_SYMBOL               "del"
#define OVERWRITE_SYMBOL            "overwrite"
#define CLOSE_SYMBOL                "close"
#define BITMAP_SYMBOL               "bitmap"


//
// WINDOW EVENTS
//
#define CKINIT_EVENT                    "init"
#define CKDESTROY_EVENT                 "destroy"
#define CKFOCUS_EVENT                   "focus"
#define CKBLUR_EVENT                    "blur"
#define CKMOVE_EVENT                    "move"
#define CKSIZE_EVENT                    "size"
#define CKLBUTTONDBLCLICK_EVENT         "ldblclick"
#define CKLBUTTONDDOWN_EVENT            "lbuttondown"
#define CKLBUTTONDUP_EVENT              "lbuttonup"
#define CKRBUTTONDBLCLICK_EVENT         "rdblclick"
#define CKRBUTTONDDOWN_EVENT            "rbuttondown"
#define CKRBUTTONDUP_EVENT              "rbuttonup"

//
// BUTTON EVENTS
//
#define CKBNCLICK_EVENT                 "click"
#define CKBNDBLCLICK_EVENT              "dblclick"
#define CKBNDISABLE_EVENT               "disable"
#define CKBNPUSH_EVENT                  "push"
#define CKBNUNPUSH_EVENT                "unpush"
//#define CKBNENABLE_EVENT "enable"
//#define CKBNDISABLE_EVENT "disable"

//
// EDIT EVENTS
//
#define CKEDCHANGE_EVENT                "change"
#define CKEDSELCHANGE_EVENT             "selchange" // not actually used in edit anymore
#define CKEDFOCUS_EVENT                 CKFOCUS_EVENT
#define CKEDBLUR_EVENT                  CKBLUR_EVENT

//
// LIST BOX EVENTS
//
#define CKLBDBLCLICK_EVENT              CKBNDBLCLICK_EVENT
#define CKLBFOCUS_EVENT                 CKFOCUS_EVENT
#define CKLBBLUR_EVENT                  CKBLUR_EVENT
#define CKLBSELCANCEL_EVENT             "selcancel"
#define CKLBSELCHANGE_EVENT             CKEDSELCHANGE_EVENT

//
// COMBO BOX EVENTS
//
#define CKCBCLOSEUP_EVENT               "closeup"
#define CKCBDBLCLICK_EVENT              CKBNDBLCLICK_EVENT
#define CKCBDROPDOWN_EVENT              "dropdown"
#define CKCBEDITCHANGE_EVENT            "editchange"
#define CKCBFOCUS_EVENT                 CKFOCUS_EVENT
#define CKCBBLUR_EVENT                  CKBLUR_EVENT
#define CKCBSELCHANGE_EVENT             CKEDSELCHANGE_EVENT
#define CKCBSELENDCANCEL_EVENT          "selendcancel"
#define CKCBSELENDOK_EVENT              "selendok"

//
// STATIC EVENTS
//
#define CKSTCLICKED_EVENT               CKBNCLICK_EVENT
#define CKSTDBLCLICK_EVENT              CKBNDBLCLICK_EVENT
#define CKSTDISABLE_EVENT               CKBNDISABLE_EVENT
#define CKSTENABLE_EVENT                "enable"

//
// NOT YET IMPLEMENTED EVENTS
//
#define CKTIMER_EVENT                   "timer"


//
// VARAIBLE NAME
//
#define CKEDITTEXT                      "text"
#define CKEDITSEL                       "sel"
#define CKLISTBOXALL                    "all"
#define CKLISTBOXSELPOS                 "selpos"
#define CKCOMBOBOXEDIT                  "edit"
//
// CLASS NAME
//
#define CKDIALOGCLASSNAME           "ckDialog"

//
// RC SETTING
//
#define CKDIALOGCONFIG              "*ckdialog"
#define CKEVENTCONFIG               "*onckdialogevent"
#define CKDIALOGINHERITED           "ckdialoginherit"
#define CKDIALOGSPECIALPOINTERS     "ckdialogusespecialpointers"
#define CKDIALOGSEPARATOR           "ckDialogSeparator"



//
// Global variables
//
extern HINSTANCE g_hInstance;
extern char *ckErrorStringArray[];
extern char *ckTokenStringArray[];


//
// Utility Functions
//
COLORREF strtocolor(const char *str);
#endif