/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef _CK_MISCPARSER_H_
#define _CK_MISCPARSER_H_

#include "ckParser.h"
#include "ckDialog.h"
#include "ckControl.h"

class ckStream;

//
// normal small parser
//
class ckIntParser : public ckParser
{
public:
    ckIntParser(ckControl &control);

    virtual ckError parse(ckStream &stream);

    virtual int getInt() {return _i;}
protected:
    int _i;
    ckControl &_control;
};

class ckIndexParser : public ckParser
{
public:
    ckIndexParser();

    virtual ckError parse(ckStream &stream);

    virtual string getString() { return _str;}
    virtual int getIndex() {return _index;}

protected:
    int _index;
    string _str;
};

//
// attribute parser
//
class ckSizeParser : public ckParser
{
public:
    ckSizeParser(RECT &r, ckControl &control);
    virtual ckError parse(ckStream &stream);

protected:
    RECT &_r;
    ckControl &_control;
};

class ckStyleParser : public ckParser
{
public:
    ckStyleParser(DWORD &style, ckControl::ControlStyleT *stylegallery);

    virtual ckError parse(ckStream &stream);


protected:
    DWORD &_style;
    ckControl::ControlStyleT *_stylegallery;
};


#endif