/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef _CK_SETTINGS_H_
#define _CK_SETTINGS_H_

#include "ckDialog.h"

class ckSettings
{
public:
    static ckSettings *instance();

    bool getInherited() const { return _inherited;}
    void setInherited(bool inherit) { _inherited = inherit;}
    
    bool useSpecialPointers() const { return _specialpointers;}
    void setSpecialPointers(bool special) { _specialpointers = special;}

    string getSeparator() const { return _separator;}
    void setSeparator(string const &sep) { _separator = sep;}


protected:
    ckSettings() 
    {
        retreiveSettings();
    }

    virtual void retreiveSettings()
    {
        _inherited = false;
        _specialpointers = false;
        _separator = ":";
    }

    static auto_ptr<ckSettings> _instance;
    
    bool _inherited; // only upward inheritance
    bool _specialpointers;
    string _separator;
};


class ckStepSettings : public ckSettings
{
protected:
    virtual void retreiveSettings()
    {
        setInherited(GetRCBool(CKDIALOGINHERITED, TRUE) == TRUE);
        setSpecialPointers(GetRCBool(CKDIALOGSPECIALPOINTERS, TRUE) == TRUE);
        char buffer[0xFF];
        GetRCString(CKDIALOGSEPARATOR, buffer, ":", 0xFF);
        setSeparator(buffer);
    }
};


#endif